Attribute VB_Name = "AccessToExel"
Option Explicit
Dim stCell As ExlCell

Sub ConvertAccessToExel(FilePath As String)
    Dim i As Integer
        Form1.ProgressBar1.Visible = True
        Form1.MousePointer = vbHourglass   ' Change mousepointer
        Set oExcel = CreateObject("Excel.Application")
        oExcel.Workbooks.Add
        Set Db = OpenDatabase(FilePath)
        Form1.StatusBar1.Panels(1).Text = "Converting.."
        Form1.ProgressBar1.Min = 0
        Form1.ProgressBar1.Max = Db.TableDefs.Count * 100
        For i = 1 To Db.TableDefs.Count
            With Db.TableDefs(i - 1)
                If Left(.Name, 4) <> "MSys" Then
                AddSheet (Db.TableDefs(i - 1).Name)
                Set objExlSht = oExcel.ActiveWorkbook.Sheets(.Name)
                Set Rs = Db.OpenRecordset(.Name, dbOpenSnapshot)
                stCell.row = 1
                stCell.col = 1
                CopyRecords Rs, objExlSht, stCell
                
                Form1.ProgressBar1.Value = i * 100
                End If
            End With
        Next i
        objExlSht.SaveAs Form1.Label2.Caption
        objExlSht.Application.Quit
        Set objExlSht = Nothing
        Set oExcel = Nothing
        Set Rs = Nothing
        Set Db = Nothing
        Form1.MousePointer = vbDefault
        Form1.StatusBar1.Panels(1).Text = "Done..."
End Sub
Private Sub AddSheet(SHTName As String)
    oExcel.ActiveWorkbook.Sheets.Add
    oExcel.ActiveWorkbook.ActiveSheet.Name = SHTName
End Sub
Private Sub CopyRecords(Rcs As Recordset, ws As Worksheet, StartingCell As ExlCell)
        Dim SomeArray() As Variant
        Dim row As Long, col As Long
        Dim fd As Field
        Rcs.MoveLast
        ReDim SomeArray(Rcs.RecordCount + 1, Rcs.Fields.Count)
        col = 0
        For Each fd In Rcs.Fields
           SomeArray(0, col) = fd.Name
           col = col + 1
        Next
        Rcs.MoveFirst
        For row = 1 To Rcs.RecordCount - 1
            For col = 0 To Rcs.Fields.Count - 1
                SomeArray(row, col) = Rcs.Fields(col).Value
                If IsNull(SomeArray(row, col)) Then SomeArray(row, col) = ""
            Next
            Rcs.MoveNext
        Next
        ws.Range(ws.Cells(StartingCell.row, StartingCell.col), ws.Cells(StartingCell.row + Rs.RecordCount + 1, StartingCell.col + Rs.Fields.Count)).Value = SomeArray
End Sub

